/////////////////////////////////////////// Plot - Macro.h (mwx,16.02.06) /////
#import <Cocoa/Cocoa.h>
@class Manager;
@class PlotDocument;
@class PlotView;
@class DataBuffer;
@class Expression;

@interface Macro : NSObject <NSCoding> {
	@public
	NSMutableString *name,*src;                         // macro name and content
	int shortcut;                                               // macro shortcut
	int colormode;                                             // macro colormode

	NSMutableArray *CMD;                                        // commmand array
	NSMutableArray *B;                                     // buffer option array
	NSMutableArray *A;                                       // axis option array
	NSMutableArray *R;                                      // range option array
	double D[16];                                          // double option array
	int I[16];                                            // integer option array
	BOOL O[16];                                            // option exists array
	NSMutableArray *S,*SS;                // string & orginal string option array

	Manager *M;                                            // connections to Plot
	PlotDocument *PD;
	PlotView *PV;
	DataBuffer *DB;

	BOOL OK;                                                   // command ok flag
	int ERR;                                                       // error count
	BOOL CANCEL;                                              // macro abort flag

	BOOL LOOPNEXT;                                                   // loop data
	NSMutableArray *LOOP;
	int LOOPSTART;
	double LOOPVAL;

	BOOL IFMODE,IFCOND;                                     // if,ele, endif data

	double th,tw;                                          // text width & height
}

- (id)init;
- (id)initWithSrc:(NSString *)aname:(NSString *)asrc:(int)ashortcut;
- (void)dealloc;
- (NSMutableString *)name;
- (NSMutableString *)src;
- (int)shortcut;
- (void)encodeWithCoder:(NSCoder *)coder;- (id)initWithCoder:(NSCoder *)coder;
- (NSColor *)getColor:(double)a:(double)b:(double)c;
- (void)parseMacro;
- (BOOL)chk:(NSString *)cmd:(NSString *)opt:(int)mo:(NSArray *)cmds;
- (BOOL)expr:(NSString *)expr:(int)no:(BOOL)showerr;
- (double)exprval:(NSString *)expr:(BOOL)showerr;
- (void)setupexpr:(Expression *)E;

@end ///////////////////////////////////////////////////////////////////// END
